/*
        Program ..... XW
        File Info ... Read README and LICENSE
*/

#include "global.h"
#include <gtk/gtk.h>
#include <gdk_imlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

gint current_row = 0;
int select_made = 0;

GtkWidget *clist;

void list_info(int the_column, int the_row)
{
	gchar	*gdata = NULL;

	bzero(return_info, 1024);

	gtk_clist_get_text( (GtkCList *) clist, the_row, the_column, &gdata);

	sprintf(return_info, "%s", gdata);

	return;
}

void xw_clist_append()
{
	gchar	*user[1][2];

	user[0][0] = userlist->username;
	user[0][1] = userlist->tty;

	gtk_clist_insert( (GtkCList *) clist, row_total, user[0]);

	row_total++;

	return;
}

void wipe_userlist(struct __userlist *node)
{
        if(node->next != NULL)
                wipe_userlist(node->next);
        free(node);

        return;
}

void do_remove(int row_kill)
{
	gtk_clist_remove ( (GtkCList *) clist, row_kill);

	return;
}

void check_to_remove()
{
	int append_it, previous;
	struct __userlist *temp;

	for (previous = 0; previous < row_total; previous++)
	{
		append_it = -1;
		for( temp = userlist_head; temp != NULL; temp = temp->next)
		{
			list_info(1, previous);
			if (strcmp(temp->tty, return_info) == 0)
			{
				list_info(0, previous);
				if (strcmp(temp->username, return_info) == 0 )
					append_it = previous;
			}
		}

		if (append_it == -1)
			do_remove(previous);
	}

	return;
}

void update( )
{
	if( userlist_head == NULL )
		free(userlist_head);
	else
	{
		wipe_userlist(userlist_head);
//		free(userlist_head);
	}

	userlist_head = (struct __userlist *) malloc((unsigned) sizeof(struct __userlist));
	userlist = userlist_head;

	do_it();

	check_to_remove();

	return;
}

void kill_window( gpointer which )
{
	gtk_widget_destroy(which);
}

void selection_made( GtkWidget *clist, gint row, gint column, GdkEventButton *event, gpointer data )
{
	int			i;
	gchar			*text;
	GtkWidget		*vbox;
	GtkWidget		*frame;
	GtkWidget		*label;
	GtkWidget		*button_close;
	GtkWidget		*user_window;
	struct __userlist	*temp;
	char			tty[1024], username[1024];
	int			blah = 0;
	char			hostname_work[128];


	gtk_clist_get_text(GTK_CLIST(clist), row, column, &text);

	current_row = row;

	if( select_made == 1 )
	{
		select_made = 0;
		return;
	}

	list_info(0, row);
	strcpy(username, return_info);
	list_info(1, row);
	strcpy(tty, return_info);

	for (temp = userlist_head; temp != NULL && blah == 0; temp = temp->next)
		if (strcmp(temp->tty, tty) == 0 && strcmp(temp->username, username) == 0 )
			break;

	user_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_signal_connect (GTK_OBJECT (user_window), "delete_event", (GtkSignalFunc) kill_window, user_window);

	gtk_window_set_title (GTK_WINDOW (user_window), temp->username);
	vbox = gtk_vbox_new (FALSE, 5);
	gtk_container_add (GTK_CONTAINER (user_window), vbox);
	gtk_container_set_border_width (GTK_CONTAINER (user_window), 5);

	frame = gtk_frame_new ("Username");
	label = gtk_label_new (temp->username);
	gtk_frame_set_shadow_type ( (GtkFrame *) frame, (GtkShadowType) GTK_SHADOW_IN);
	gtk_misc_set_alignment(GTK_MISC(label), 0.05f, 0.5f);
	gtk_container_add (GTK_CONTAINER (frame), label);
	gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, FALSE, 0);

	frame = gtk_frame_new ("TTY");
	label = gtk_label_new (temp->tty);
	gtk_frame_set_shadow_type ( (GtkFrame *) frame, (GtkShadowType) GTK_SHADOW_IN);
	gtk_misc_set_alignment(GTK_MISC(label), 0.05f, 0.5f);
	gtk_label_set_justify ((GtkLabel *) label, GTK_JUSTIFY_LEFT);
	gtk_container_add (GTK_CONTAINER (frame), label);
	gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, FALSE, 0);

	sprintf(hostname_work, "  %s", temp->hostname);
	for(i = strlen(hostname_work); i < 64; i++)
		hostname_work[i] = ' ';
	hostname_work[64] = '\0';

	frame = gtk_frame_new ("Hostname");
	label = gtk_label_new (hostname_work);
	gtk_frame_set_shadow_type ( (GtkFrame *) frame, (GtkShadowType) GTK_SHADOW_IN);
	gtk_misc_set_alignment(GTK_MISC(label), 0.05f, 0.5f);
	gtk_label_set_justify ((GtkLabel *) label, GTK_JUSTIFY_LEFT);
	gtk_container_add (GTK_CONTAINER (frame), label);
	gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, FALSE, 0);

	frame = gtk_frame_new ("Sign On");
	label = gtk_label_new (temp->signon);
	gtk_frame_set_shadow_type ( (GtkFrame *) frame, (GtkShadowType) GTK_SHADOW_IN);
	gtk_misc_set_alignment(GTK_MISC(label), 0.03f, 0.5f);
	gtk_label_set_justify ((GtkLabel *) label, GTK_JUSTIFY_LEFT);
	gtk_container_add (GTK_CONTAINER (frame), label);
	gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, FALSE, 0);

	frame = gtk_frame_new ("Idle");
	label = gtk_label_new (temp->idle);
	gtk_frame_set_shadow_type ( (GtkFrame *) frame, (GtkShadowType) GTK_SHADOW_IN);
	gtk_misc_set_alignment(GTK_MISC(label), 0.0f, 0.5f);
	gtk_label_set_justify ((GtkLabel *) label, GTK_JUSTIFY_LEFT);
	gtk_container_add (GTK_CONTAINER (frame), label);
	gtk_box_pack_start (GTK_BOX (vbox), frame, FALSE, FALSE, 0);

	button_close = gtk_button_new_with_label("Okay");
	gtk_box_pack_start(GTK_BOX(vbox), button_close, TRUE, TRUE, 0);
	gtk_signal_connect_object(GTK_OBJECT(button_close), "clicked", (GtkSignalFunc) kill_window, GINT_TO_POINTER(user_window));
	gtk_widget_show(button_close);

	gtk_widget_show_all (user_window);

	return;
}

void quit_time( gpointer window )
{
	gtk_widget_destroy(window);

	exit(0);
}

void main_window_setup_dan_quale_blue_monkey()
{
	GtkWidget *window;
	GtkWidget *vbox, *hbox;
	GtkWidget *scrolled_window;
	GtkWidget *button_close;
	gchar *titles[2] = { "Username", "tty" };

	gtk_init(NULL, NULL);

	window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_widget_set_usize(GTK_WIDGET(window), 150, 230);

	gtk_window_set_title(GTK_WINDOW(window), "System Users");
	gtk_signal_connect(GTK_OBJECT(window), "destroy", GTK_SIGNAL_FUNC(gtk_main_quit), NULL);

	vbox=gtk_vbox_new(FALSE, 5);
	gtk_container_set_border_width(GTK_CONTAINER(vbox), 5);
	gtk_container_add(GTK_CONTAINER(window), vbox);
	gtk_widget_show(vbox);
                             
	scrolled_window = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
                                                             GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);

	gtk_box_pack_start(GTK_BOX(vbox), scrolled_window, TRUE, TRUE, 0);
	gtk_widget_show (scrolled_window);

	clist = gtk_clist_new_with_titles( 2, titles);

	gtk_signal_connect(GTK_OBJECT(clist), "select_row",
                                                GTK_SIGNAL_FUNC(selection_made),
                                                NULL);

	gtk_clist_set_shadow_type (GTK_CLIST(clist), GTK_SHADOW_OUT);

	gtk_clist_set_column_width (GTK_CLIST(clist), 0, 60);

	gtk_container_add(GTK_CONTAINER(scrolled_window), clist);
	gtk_widget_show(clist);

	hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, FALSE, TRUE, 0);
	gtk_widget_show(hbox);

	button_close = gtk_button_new_with_label("Quit");
	gtk_box_pack_start(GTK_BOX(vbox), button_close, FALSE, FALSE, 0);
	gtk_signal_connect_object(GTK_OBJECT(button_close), "clicked", (GtkSignalFunc) quit_time, GINT_TO_POINTER(window));
	gtk_widget_show(button_close);

	gtk_widget_show(window);

	return;
}

int main()
{
/*	int pid;

        switch ( pid = fork () )
        {
                case -1: exit(-1);
                case 0:
                {
                        setsid ();
                        break;
                }
                default: exit(0);
        }
*/
	row_total = 0;
	userlist_head = (struct __userlist *) malloc((unsigned) sizeof(struct __userlist));
	userlist_head = NULL;

	main_window_setup_dan_quale_blue_monkey();

	gtk_timeout_add( 1000, (GtkFunction) update, NULL);
	update();

	gtk_main();

	exit(0);
}
	
